javax.servlet.http

## Class Cookie

- java.lang.Object
- - javax.servlet.http.Cookie

- All Implemented Interfaces:
    Serializable, Cloneable

      public class Cookie
      extends Object
      implements Cloneable, Serializable

  Creates a cookie, a small amount of information sent by a servlet to a Web browser, saved by the browser, and later sent back to the server. A cookie's value can uniquely identify a client, so cookies are commonly used for session management.

  A cookie has a name, a single value, and optional attributes such as a comment, path and domain qualifiers, a maximum age, and a version number. Some Web browsers have bugs in how they handle the optional attributes, so use them sparingly to improve the interoperability of your servlets.

  The servlet sends cookies to the browser by using the `HttpServletResponse.addCookie(javax.servlet.http.Cookie)` method, which adds fields to HTTP response headers to send cookies to the browser, one at a time. The browser is expected to support 20 cookies for each Web server, 300 cookies total, and may limit cookie size to 4 KB each.

  The browser returns cookies to the servlet by adding fields to HTTP request headers. Cookies can be retrieved from a request by using the `HttpServletRequest.getCookies()` method. Several cookies might have the same name but different path attributes.

  Cookies affect the caching of the Web pages that use them. HTTP 1.0 does not cache pages that use cookies created with this class. This class does not support the cache control defined with HTTP 1.1.

  This class supports both the Version 0 (by Netscape) and Version 1 (by RFC 2109) cookie specifications. By default, cookies are created using Version 0 to ensure the best interoperability.

  Author:
    Various
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Cookie(String name, String value)` Constructs a cookie with the specified name and value.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Object` | `clone()` Overrides the standard `java.lang.Object.clone` method to return a copy of this Cookie.
    `String` | `getComment()` Returns the comment describing the purpose of this cookie, or `null` if the cookie has no comment.
    `String` | `getDomain()` Gets the domain name of this Cookie.
    `int` | `getMaxAge()` Gets the maximum age in seconds of this Cookie.
    `String` | `getName()` Returns the name of the cookie.
    `String` | `getPath()` Returns the path on the server to which the browser returns this cookie.
    `boolean` | `getSecure()` Returns `true` if the browser is sending cookies only over a secure protocol, or `false` if the browser can send cookies using any protocol.
    `String` | `getValue()` Gets the current value of this Cookie.
    `int` | `getVersion()` Returns the version of the protocol this cookie complies with.
    `boolean` | `isHttpOnly()` Checks whether this Cookie has been marked as HttpOnly.
    `void` | `setComment(String purpose)` Specifies a comment that describes a cookie's purpose.
    `void` | `setDomain(String domain)` Specifies the domain within which this cookie should be presented.
    `void` | `setHttpOnly(boolean isHttpOnly)` Marks or unmarks this Cookie as HttpOnly.
    `void` | `setMaxAge(int expiry)` Sets the maximum age in seconds for this Cookie.
    `void` | `setPath(String uri)` Specifies a path for the cookie to which the client should return the cookie.
    `void` | `setSecure(boolean flag)` Indicates to the browser whether the cookie should only be sent using a secure protocol, such as HTTPS or SSL.
    `void` | `setValue(String newValue)` Assigns a new value to this Cookie.
    `void` | `setVersion(int v)` Sets the version of the cookie protocol that this Cookie complies with.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Cookie

          public Cookie(String name,
                String value)

      Constructs a cookie with the specified name and value.

      The name must conform to RFC 2109. However, vendors may provide a configuration option that allows cookie names conforming to the original Netscape Cookie Specification to be accepted.

      The name of a cookie cannot be changed once the cookie has been created.

      The value can be anything the server chooses to send. Its value is probably of interest only to the server. The cookie's value can be changed after creation with the `setValue` method.

      By default, cookies are created according to the Netscape cookie specification. The version can be changed with the `setVersion` method.

      Parameters:
        `name` - the name of the cookie
        `value` - the value of the cookie
      Throws:
        `IllegalArgumentException` - if the cookie name is null or empty or contains any illegal characters (for example, a comma, space, or semicolon) or matches a token reserved for use by the cookie protocol
      See Also:
        `setValue(java.lang.String)`, `setVersion(int)`

  - ### Method Detail

    - #### setComment

          public void setComment(String purpose)

      Specifies a comment that describes a cookie's purpose. The comment is useful if the browser presents the cookie to the user. Comments are not supported by Netscape Version 0 cookies.
      Parameters:
        `purpose` - a `String` specifying the comment to display to the user
      See Also:
        `getComment()`

    - #### getComment

          public String getComment()

      Returns the comment describing the purpose of this cookie, or `null` if the cookie has no comment.
      Returns:
        the comment of the cookie, or `null` if unspecified
      See Also:
        `setComment(java.lang.String)`

    - #### setDomain

          public void setDomain(String domain)

      Specifies the domain within which this cookie should be presented.

      The form of the domain name is specified by RFC 2109. A domain name begins with a dot (`.foo.com`) and means that the cookie is visible to servers in a specified Domain Name System (DNS) zone (for example, `www.foo.com`, but not `a.b.foo.com`). By default, cookies are only returned to the server that sent them.

      Parameters:
        `domain` - the domain name within which this cookie is visible; form is according to RFC 2109
      See Also:
        `getDomain()`

    - #### getDomain

          public String getDomain()

      Gets the domain name of this Cookie.

      Domain names are formatted according to RFC 2109.

      Returns:
        the domain name of this Cookie
      See Also:
        `setDomain(java.lang.String)`

    - #### setMaxAge

          public void setMaxAge(int expiry)

      Sets the maximum age in seconds for this Cookie.

      A positive value indicates that the cookie will expire after that many seconds have passed. Note that the value is the maximum age when the cookie will expire, not the cookie's current age.

      A negative value means that the cookie is not stored persistently and will be deleted when the Web browser exits. A zero value causes the cookie to be deleted.

      Parameters:
        `expiry` - an integer specifying the maximum age of the cookie in seconds; if negative, means the cookie is not stored; if zero, deletes the cookie
      See Also:
        `getMaxAge()`

    - #### getMaxAge

          public int getMaxAge()

      Gets the maximum age in seconds of this Cookie.

      By default, `-1` is returned, which indicates that the cookie will persist until browser shutdown.

      Returns:
        an integer specifying the maximum age of the cookie in seconds; if negative, means the cookie persists until browser shutdown
      See Also:
        `setMaxAge(int)`

    - #### setPath

          public void setPath(String uri)

      Specifies a path for the cookie to which the client should return the cookie.

      The cookie is visible to all the pages in the directory you specify, and all the pages in that directory's subdirectories. A cookie's path must include the servlet that set the cookie, for example, /catalog, which makes the cookie visible to all directories on the server under /catalog.

      Consult RFC 2109 (available on the Internet) for more information on setting path names for cookies.

      Parameters:
        `uri` - a `String` specifying a path
      See Also:
        `getPath()`

    - #### getPath

          public String getPath()

      Returns the path on the server to which the browser returns this cookie. The cookie is visible to all subpaths on the server.
      Returns:
        a `String` specifying a path that contains a servlet name, for example, /catalog
      See Also:
        `setPath(java.lang.String)`

    - #### setSecure

          public void setSecure(boolean flag)

      Indicates to the browser whether the cookie should only be sent using a secure protocol, such as HTTPS or SSL.

      The default value is `false`.

      Parameters:
        `flag` - if `true`, sends the cookie from the browser to the server only when using a secure protocol; if `false`, sent on any protocol
      See Also:
        `getSecure()`

    - #### getSecure

          public boolean getSecure()

      Returns `true` if the browser is sending cookies only over a secure protocol, or `false` if the browser can send cookies using any protocol.
      Returns:
        `true` if the browser uses a secure protocol, `false` otherwise
      See Also:
        `setSecure(boolean)`

    - #### getName

          public String getName()

      Returns the name of the cookie. The name cannot be changed after creation.
      Returns:
        the name of the cookie

    - #### setValue

          public void setValue(String newValue)

      Assigns a new value to this Cookie.

      If you use a binary value, you may want to use BASE64 encoding.

      With Version 0 cookies, values should not contain white space, brackets, parentheses, equals signs, commas, double quotes, slashes, question marks, at signs, colons, and semicolons. Empty values may not behave the same way on all browsers.

      Parameters:
        `newValue` - the new value of the cookie
      See Also:
        `getValue()`

    - #### getValue

          public String getValue()

      Gets the current value of this Cookie.
      Returns:
        the current value of this Cookie
      See Also:
        `setValue(java.lang.String)`

    - #### getVersion

          public int getVersion()

      Returns the version of the protocol this cookie complies with. Version 1 complies with RFC 2109, and version 0 complies with the original cookie specification drafted by Netscape. Cookies provided by a browser use and identify the browser's cookie version.
      Returns:
        0 if the cookie complies with the original Netscape specification; 1 if the cookie complies with RFC 2109
      See Also:
        `setVersion(int)`

    - #### setVersion

          public void setVersion(int v)

      Sets the version of the cookie protocol that this Cookie complies with.

      Version 0 complies with the original Netscape cookie specification. Version 1 complies with RFC 2109.

      Since RFC 2109 is still somewhat new, consider version 1 as experimental; do not use it yet on production sites.

      Parameters:
        `v` - 0 if the cookie should comply with the original Netscape specification; 1 if the cookie should comply with RFC 2109
      See Also:
        `getVersion()`

    - #### clone

          public Object clone()

      Overrides the standard `java.lang.Object.clone` method to return a copy of this Cookie.
      Overrides:
        `clone` in class `Object`

    - #### setHttpOnly

          public void setHttpOnly(boolean isHttpOnly)

      Marks or unmarks this Cookie as HttpOnly.

      If `isHttpOnly` is set to `true`, this cookie is marked as HttpOnly, by adding the `HttpOnly` attribute to it.

      HttpOnly cookies are not supposed to be exposed to client-side scripting code, and may therefore help mitigate certain kinds of cross-site scripting attacks.

      Parameters:
        `isHttpOnly` - true if this cookie is to be marked as HttpOnly, false otherwise
      Since:
        Servlet 3.0

    - #### isHttpOnly

          public boolean isHttpOnly()

      Checks whether this Cookie has been marked as HttpOnly.
      Returns:
        true if this Cookie has been marked as HttpOnly, false otherwise
      Since:
        Servlet 3.0

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.